<?php
# This file is distributed under GNU GPLv1 and further versions.
# This file was written by Zdenek Styblik
# This file is part of weathermap4rrd-ng
#
# Zdenek Styblik
# e-mail: zdenek <dot> styblik <at> gmail <dot> com
#
# Last update: 2008-01-31
#
class formlink extends defaultLib {
	public $auto_index;
	public $scriptname;
	public $settings;

	function __construct() {
		$this->auto_index = -1;
		$this->settings = new StdClass;
		$settings = $this->settings;
		$settings->config = new StdClass;
		$settings->xmlobject = new StdClass;
		$settings->xmlobject->debug = new StdClass;
		$this->scriptname = $this->getScriptname();
		$settings->xmlobject->scriptname = $this->getScriptname();
	}

	function __destruct() {
		$this->settings;
		$this->auto_index;
	}

	public function init() {
		if (isset($_GET['action'])) {
			$action = $this->stripMe($_GET['action']);
		} else {
			$action = "foo";
		}
		switch ($action) {
			case 'new':
				$this->linkAddForm();
				break;
			case 'edit':
				$this->linkEditForm();
				break;
			case 'addlink':
				$this->linkAdd();
				break;
			case 'editlink':
				$this->linkEdit();
				break;
			case 'deletelink':
				$this->linkDelete();
				break;
			default:
				$this->linkAddForm();
				break;
		}
	}

	// add link form
	private function linkAddForm() {
		$xml = $this->settings->xmlobject;
		$path = $this->getPath();
		require_once "{$path}lib/configfile.php";
		$configfile = new config_file();
		if ($configfile->readconfig() !== false) {
			$config = $configfile->getConfig();
			$internodecount = $configfile->getINODEScount();
			$xml->scriptname = $this->scriptname;
			$xml->arrowtype = new StdClass;
			$xml->arrowtype = $this->getArrowType();
			$xml->nodea = new StdClass;
			$xml->nodeb = new StdClass;
			if (isset($config->nodes) && is_object($config->nodes)) {
				foreach ($config->nodes as $node) {
					$this->auto_index++;
					$xml->nodea->entry[$this->auto_index] = new StdClass;
					$xml->nodea->entry[$this->auto_index]->name = $node->name;
					$xml->nodeb->entry[$this->auto_index] = new StdClass;
					$xml->nodeb->entry[$this->auto_index]->name = $node->name;
				}
			} else {
				$this->setError("nodes not set; set some nodes first; aborting;");
				return 50;
			}
			for ($a = 0; $a < $internodecount; $a++) {
				$xml->internode[$a] = new StdClass;
				$xml->internode[$a]->num = $a;
			}
			$xml->netunit = $this->getNetUnits();
			// buttons
			$xml->button = new StdClass;
			$xml->button->entry[0] = new StdClass;
			$xml->button->entry[0]->urllabel = "Add";
			$xml->button->entry[0]->margin = 100;
			$xml->button->entry[0]->url = "javascript:document.formlink.submit()";
			$xml->button->entry[1] = new StdClass;
			$xml->button->entry[1]->urllabel = "Cancel";
			$xml->button->entry[1]->margin = 150;
			$xml->button->entry[1]->url = $this->scriptname . "?module=editor";
			// form action
			$xml->formaction = $this->scriptname . "?module=formlink&#38;action=addlink";
			// layout
			$this->settings->layout = "form_link.xsl";
		} else {
			require_once "{$path}modules/editor.php";
			$editor = new editor();
			$editor->init();
			$this->settings = $editor->settings;
		}
	}

	// add link function
	private function linkAdd() {
		$RC = 0;
		$path = $this->getPath();
		$config = $this->settings->config;
		require_once("{$path}lib/configfile.php");
		$configfile = new config_file();
		if ($configfile->readconfig() == false) {
			// error
			$this->setError("config file not found;");
		} else {
			$config = $configfile->getConfig();
			// name
			if (isset($_POST['name'])) {
				$name = $this->stripMe($_POST['name']);
				$name = preg_replace('/^\s+/', '', $name);
				$name = preg_replace('/\s+$/', '', $name);
				$name = preg_replace('/\s+/', '_', $name);
				$xml = new StdClass;
				if (!empty($name)) {
					if (isset($config->links->{$name})) {
						// error
						setDebugMsg("linkname already taken;");
						$RC = 1;
					} else {
						if (is_numeric(substr($name, 0, 1))) {
							setDebugMsg("link-name starts with number!;");
							$RC = 1;
						} else {
							$xml->name = $name;
						}
					}
				} else {
					// error
					setDebugMsg("name not set;");
					$RC = 1;
				}
			} else {
				// error
				setDebugMsg("name not set;");
				$RC = 1;
			} // end - name
			// from
			if (isset($_POST['nodea']) && !empty($_POST['nodea'])) {
				# todo - possible todo; check if node exists
				$xml->from = $this->stripMe($_POST['nodea']);
			} else {
				$this->setError("node *from* doesn't exist; aborting;");
				return 10;
			} // end - from
			// to
			if (isset($_POST['nodeb']) && !empty($_POST['nodeb'])) {
				# todo - possible todo; check if node exists
				$xml->to = $this->stripMe($_POST['nodeb']);
			} else {
				$this->setError("node *to* doesn't exist; aborting;");
				return 11;
			} // end - to
			// target
			$this->setValue('target', $xml, 0);
			// target-in
			$this->setValue('targetin', $xml, 0);
			// target-out
			$this->setValue('targetout', $xml, 0);
			// inpos
			$this->setValue('inpos', $xml, 1);
			// outpos
			$this->setValue('outpos', $xml, 1);
			// unit
			$this->setValue('unit', $xml, 0);
			if (isset($xml->unit))
				$xml->unit = $this->checkUnit($xml->unit);
			// displayvalue
			if (isset($_POST['displayvalue']) && $_POST['displayvalue'] == 'on') {
				$xml->displayvalue = '1';
			} else {
				$xml->displayvalue = '0';
			}
			// ratein
			$this->setValue('ratein', $xml, 1);
			// rateout
			$this->setValue('rateout', $xml, 1);
			// arrow
			$this->setValue('arrow', $xml, 0);
			if (isset($xml->arrow))
				$xml->arrow = $this->checkArrow($xml->arrow);
			// linkinfourl
			$this->setValue('linkinfourl', $xml, 0);
			// linkoverlibgraph
			$this->setValue('linkoverlibgraph', $xml, 0);
			// group
			$this->setValue('group', $xml, 0);
			// internodes
			// display internodes
			if(isset($_POST['internodedisplay']) && $_POST['internodedisplay'] == 'on') {
				$xml->internodedisplay = 1;
			} else {
				$xml->internodedisplay = 0;
			}
			// display mid internode
			if (isset($_POST['internodedisplaymid']) && $_POST['internodedisplaymid'] == 'on') {
				$xml->internodedisplaymid = 1;
			} else {
				$xml->internodedisplaymid = 0;
			}
			// display number(s) of internode(s)
			if (isset($_POST['internodedisplaynum']) && $_POST['internodedisplaynum'] == 'on') {
				$xml->internodedisplaynum = 1;
			} else {
				$xml->internodedisplaynum = 0;
			}
			// internodes
			$internodecount = $configfile->getINODESCount();
			for ($i = 0; $i < $internodecount; $i++) {
				if (isset($_POST["Xinode{$i}"]) && is_numeric($_POST["Xinode{$i}"]) && isset($_POST["Yinode{$i}"]) && is_numeric($_POST["Yinode{$i}"])) {
					$xml->internode[$i] = new StdClass;
					$xml->internode[$i]->x = $this->stripMe($_POST["Xinode{$i}"]);
					$xml->internode[$i]->y = $this->stripMe($_POST["Yinode{$i}"]);
				}
			}
			$xml->inodegroup = rand(500, 65536);
			if ($RC == 0) {
				$config->links->{$xml->name} = new StdClass;
				$config->links->{$xml->name} = $xml;
				$xml2save = "<root>\n";
				$xml2save.= $this->objToXML($config);
				$xml2save.= "</root>";
				$configfile->writeconfig($xml2save);
				header("Location: {$this->scriptname}?module=editor");
				exit();
			} else {
				// error
				foreach ($xml as $k=>$v) {
					$this->settings->xmlobject->$k = $v;
				}
				$this->linkAddForm();
			}
		}
	}

	// edit link form
	private function linkEditForm() {
		if (isset($_POST['link']) && !empty($_POST['link'])) {
			$config = $this->settings->config;
			$path = $this->getPath();
			$xml = $this->settings->xmlobject;
			require_once "{$path}lib/configfile.php";
			$configfile = new config_file();
			if ($configfile->readconfig() == false) {
				// error
				$this->setError("config file not found;");
			} else {
				$config = $configfile->getConfig();
				$internodecount = $configfile->getINODESCount();
				$xml = $this->settings->xmlobject;
				$xml->scriptname = $this->scriptname;
				$link = $this->stripMe($_POST['link']);
				if (isset($config->links->{$link}) && is_object($config->links->{$link})) {
					$linkobj = $config->links->{$link};
					// link name
					$xml->name = $linkobj->name;
					// nodes from:to
					$xml->nodea = new StdClass;
					$xml->nodeb = new StdClass;
					if (count($config->nodes) > 0) {
						foreach ($config->nodes as $node) {
							$this->auto_index++;
							$xml->nodea->entry[$this->auto_index] = new StdClass;
							if ($linkobj->from == $node->name) {
								$xml->nodea->entry[$this->auto_index]->isselected = "yes";
							}
							$xml->nodea->entry[$this->auto_index]->name = $node->name;

							$xml->nodeb->entry[$this->auto_index] = new StdClass;
							if ($linkobj->to == $node->name) {
								$xml->nodeb->entry[$this->auto_index]->isselected = "yes";
							}
							$xml->nodeb->entry[$this->auto_index]->name = $node->name;
						}
					} else {
						setDebugMsg("set some nodes;");
					}
					// rrd file
					if (isset($linkobj->target))
						$xml->target = $linkobj->target;
					// target-in
					if (isset($linkobj->targetin) && !empty($linkobj->targetin))
						$xml->targetin = $linkobj->targetin;
					// target-out
					if (isset($linkobj->targetout) && !empty($linkobj->targetout))
						$xml->targetout = $linkobj->targetout;
					// in traffic pos
					if (isset($linkobj->inpos) && is_numeric($linkobj->inpos))
						$xml->inpos = $linkobj->inpos;
					// out traffic pos
					if (isset($linkobj->outpos) && is_numeric($linkobj->outpos))
						$xml->outpos = $linkobj->outpos;
					// arrow type
					if (isset($linkobj->arrow) && !empty($linkobj->arrow)) {
						$xml->arrowtype = $this->getArrowType($linkobj->arrow);
					} else {
						$xml->arrowtype = $this->getArrowType();
					}
					// units
					if (isset($linkobj->unit)) {
						$xml->netunit = $this->getNetUnits($linkobj->unit);
					} else {
						$xml->netunit = $this->getNetUnits();
					}
					// max input
					if (isset($linkobj->ratein) && is_numeric($linkobj->ratein))
						$xml->ratein = $linkobj->ratein;
					// max output
					if (isset($linkobj->rateout) && is_numeric($linkobj->rateout))
						$xml->rateout = $linkobj->rateout;
					// display values
					if (isset($linkobj->displayvalue) && $linkobj->displayvalue == 1)
						$xml->displayvalue = 1;
					// info url
					if (isset($linkobj->linkinfourl))
						$xml->linkinfourl = $linkobj->linkinfourl;
					// overlib
					if (isset($linkobj->linkoverlibgraph) && !empty($linkobj->linkoverlibgraph))
						$xml->linkoverlibgraph = $linkobj->linkoverlibgraph;
					// group
					if (isset($linkobj->group) && !empty($linkobj->group))
						$xml->group = $linkobj->group;
					// internodes
					if (isset($linkobj->internodedisplay) && $linkobj->internodedisplay == 1)
						$xml->internodedisplay = 1;
					if (isset($linkobj->internodedisplaymid) && $linkobj->internodedisplaymid == 1)
						$xml->internodedisplaymid = 1;
					if (isset($linkobj->internodedisplaynum) && $linkobj->internodedisplaynum == 1)
						$xml->internodedisplaynum = 1;
					if (isset($linkobj->internode)) {
						if (is_array($linkobj->internode)) {
							$a = 0;
							foreach ($linkobj->internode as $inode) {
								$xml->internode[$a] = new StdClass;
								$xml->internode[$a]->num = $a;
								$xml->internode[$a]->x = $inode->x;
								$xml->internode[$a]->y = $inode->y;
								$a++;
							}
						} elseif (is_object($linkobj->internode)) {
							$xml->internode[0] = new StdClass;
							$xml->internode[0]->num = 0;
							$xml->internode[0]->x = $linkobj->internode->x;
							$xml->internode[0]->y = $linkobj->internode->y;
							$a = 1;
						} else {
							# do nothing; this should never happen
							$this->auto_index++;
							$settings->debug->entry[$this->auto_index] = new StdClass;
							$settings->debug->entry[$this->auto_index] = "Unexpected error #01 - index.php";
						}
						for ($b = $a; $b < $internodecount; $b++) {
							$xml->internode[$b] = new StdClass;
							$xml->internode[$b]->num = $b;
						}
					} else {
						for ($a = 0; $a < $internodecount; $a++) {
							$xml->internode[$a] = new StdClass;
							$xml->internode[$a]->num = $a;
						}
					}
					// buttons
					$xml->button = new StdClass;
					$xml->button->entry[0] = new StdClass;
					$xml->button->entry[0]->urllabel = "Update";
					$xml->button->entry[0]->margin = 100;
					$xml->button->entry[0]->url = "javascript:document.formlink.submit()";
					$xml->button->entry[1] = new StdClass;
					$xml->button->entry[1]->urllabel = "Delete";
					$xml->button->entry[1]->margin = 150;
					$xml->button->entry[1]->url = $this->scriptname . "?module=formlink&#38;action=deletelink&#38;name={$link}";
					$xml->button->entry[2] = new StdClass;
					$xml->button->entry[2]->urllabel = "Cancel";
					$xml->button->entry[2]->margin = 150;
					$xml->button->entry[2]->url = $this->scriptname . "?module=editor";
					// form action
					$xml->formaction = $this->scriptname . "?module=formlink&#38;action=editlink";
					// layout
					$this->settings->layout = "form_link.xsl";
				} else {
					// error
					$this->setError("requested link doesn't exist;");
				} // if isset($config->links->link)
			}
		} else {
			// error
			$this->setError("requested link doesn't exist;");
		}
	}

	// edit link function
	private function linkEdit() {
		if (isset($_POST['name']) && !empty($_POST['name']) && isset($_POST['oldname']) && !empty($_POST['oldname'])) {
			$name = $this->stripMe($_POST['name']);
			$name = preg_replace('/\s+/', '_', $name);
			$oldname = $this->stripMe($_POST['oldname']);
			$oldname = preg_replace('/\s+/', '_', $oldname);
			$path = $this->getPath();
			require_once "{$path}lib/configfile.php";
			$configfile = new config_file();
			if ($configfile->readconfig() == false) {
				// error
				$this->setError("can't access config file; aborting;");
				return 100;
			} else {
				$config = $configfile->getConfig();
				if (isset($config->links->{$oldname})) {
					// linkname
					if ( $name !== $oldname && ( !empty($name) && !empty($oldname))) {
						if (!is_numeric(substr($name, 0, 1))) {
							// update link name and xml node
							$newlink = new StdClass;
							$newlink = $config->links->{$oldname};
							unset($config->links->{$oldname});
							$config->links->{$name} = new StdClass;
							$config->links->{$name} = $newlink;
							$link = $config->links->{$name};
							$link->name = $name;
						} else {
							$this->setError("link-name starts with integer!;");
							$_POST['link'] = $oldname;
							$this->linkEditForm();
							return 200;
						}
					} else {
						// do nothing
						// note: we do believe tag was ok before.
						$link = $config->links->{$name};
					}
					// nodes from:to
					// from
					if (isset($_POST['nodea']) && !empty($_POST['nodea'])) {
						# todo - possible todo; check if node exists
						$link->from = $this->stripMe($_POST['nodea']);
					} else {
						$this->setError("node *from* not set; aborting;");
						return 10;
					}
					// to
					if (isset($_POST['nodeb']) && !empty($_POST['nodeb'])) {
						# todo - possible todo; check if node exists
						$link->to = $this->stripMe($_POST['nodeb']);
					} else {
						$this->setError("node *to* not set; aborting;");
						return 11;
					}
					// rrd file
					$this->setValue('target', $link, 0);
					// target-in
					$this->setValue('targetin', $link, 0);
					// target-out
					$this->setValue('targetout', $link, 0);
					// in traffic pos
					$this->setValue('inpos', $link, 1);
					// out traffic pos
					$this->setValue('outpos', $link, 1);
					// arrow type
					$this->setValue('arrow', $link, 0);
					if (isset($link->arrow))
						$link->arrow = $this->checkArrow($link->arrow);
					// units
					$this->setValue('unit', $link, 0);
					if (isset($link->unit))
						$link->unit = $this->checkUnit($link->unit);
					// max input
					$this->setValue('ratein', $link, 1);
					// max output
					$this->setValue('rateout', $link, 1);
					// display values
					if (isset($_POST['displayvalue']) && $_POST['displayvalue'] == 'on') {
						$link->displayvalue = '1';
					} else {
						$link->displayvalue = '0';
					}
					// info url
					$this->setValue('linkinfourl', $link, 0);
					// overlib
					$this->setValue('linkoverlibgraph', $link, 0);
					// group
					$this->setValue('group', $link, 0);
					// internodes
					// display internodes
					if(isset($_POST['internodedisplay']) && $_POST['internodedisplay'] == 'on') {
						$link->internodedisplay = 1;
					} else {
						$link->internodedisplay = 0;
					}
					if (isset($_POST['internodedisplaymid']) && $_POST['internodedisplaymid'] == 'on') {
						$link->internodedisplaymid = 1;
					} else {
						$link->internodedisplaymid = 0;
					}
					// display number(s) of internode(s)
					if (isset($_POST['internodedisplaynum']) && $_POST['internodedisplaynum'] == 'on') {
						$link->internodedisplaynum = 1;
					} else {
						$link->internodedisplaynum = 0;
					}
					// internodes itself
					// fixme - ?
					unset($link->internode);
					$j = $configfile->getINODESCount();
					for ($i = 0; $i < $j; $i++) {
						if (isset($_POST["Xinode{$i}"]) && is_numeric($_POST["Xinode{$i}"]) && isset($_POST["Yinode{$i}"]) && is_numeric($_POST["Yinode{$i}"])) {
								$link->internode[$i] = new StdClass;
								$link->internode[$i]->x = $this->stripMe($_POST["Xinode{$i}"]);
								$link->internode[$i]->y = $this->stripMe($_POST["Yinode{$i}"]);
						}
					}
					$xml = $this->objToXML($config);
					// convert obj-2-xml
					$xml2save = "<root>\n";
					$xml2save.= $this->objToXML($config);
					$xml2save.= "</root>";
					// saveXML
					$configfile->writeconfig($xml2save);
					// redirect to index page
					header("Location: {$this->scriptname}?module=editor");
					exit();
				} else {
					// error
					$this->setError("link doesn't exist; aborting;");
					return 101;
				} // if isset($cfg->oldname)
			}
		} else {
			// error
			$this->setError("vars not set; aborting;");
		}
	}

	// delete link function
	// @return null;
	private function linkDelete() {
		if (isset($_GET['name']) && !empty($_GET['name'])) {
			$name = $this->stripMe($_GET['name']);
			$name = preg_replace('/\s+/', '_', $name);
			$path = $this->getPath();
			require_once "{$path}lib/configfile.php";
			$configfile = new config_file();
			if ($configfile->readconfig() != false) {
				$config = $configfile->getConfig();
				if (isset($config->links->{$name})) {
					// unset link
					unset($config->links->{$name});
					// convert obj-2-xml
					$xml2save = "<root>\n";
					$xml2save.= $this->objToXML($config);
					$xml2save.= "</root>";
					// saveXML
					$configfile->writeconfig($xml2save);
					// redirect to index page
					header("Location: {$this->scriptname}?module=editor");
					exit();
				} else {
					// error
					$this->setError("link not found; aborting;");
				}
			} else {
				// error
				$this->setError("config file not found; aborting;");

			}
		} else {
			// error
			$this->setError("linkname string empty; aborting;");
		}
	}
	
	// @return null;
	private function setError($errormsg = null) {
		$path = $this->getPath();
		require_once "{$path}modules/editor.php";
		$editor = new editor();
		$editor->init();
		$this->settings = $editor->settings;
		unset($editor);
		$this->auto_index++;
		$xml = $this->settings->xmlobject;
		$xml->debug->entry[$this->auto_index] = new StdClass;
		$xml->debug->entry[$this->auto_index]->text = $errormsg;
	}
	// @return $obj
	private function getArrowType($type = null) {
		$arrowtype = new StdClass;
		$arrowtype->entry[0] = new StdClass;
		$arrowtype->entry[0]->value = "normal";
		$arrowtype->entry[1] = new StdClass;
		$arrowtype->entry[1]->value = "circle";
		$arrowtype->entry[2] = new StdClass;
		$arrowtype->entry[2]->value = "halfarrow";
		switch ($type) {
			case 'circle':
				$arrowtype->entry[1]->isselected = "yes";
				break;
			case	'halfarrow':
				$arrowtype->entry[2]->isselected = "yes";
				break;
			default:
				$arrowtype->entry[0]->isselected = "yes";
				break;
		}
		return $arrowtype;
	}

	// @return $obj
	private function getNetUnits($type = null) {
		$netunit = new StdClass;
		$netunit->entry[0] = new StdClass;
		$netunit->entry[0]->value = "bits";
		$netunit->entry[1] = new StdClass;
		$netunit->entry[1]->value = "Kbits";
		$netunit->entry[2] = new StdClass;
		$netunit->entry[2]->value = "Mbits";
		$netunit->entry[3] = new StdClass;
		$netunit->entry[3]->value = "bytes";
		$netunit->entry[4] = new StdClass;
		$netunit->entry[4]->value = "Kbytes";
		$netunit->entry[5] = new StdClass;
		$netunit->entry[5]->value = "Mbytes";
		switch ($type) {
			case 'Kbits':
				$netunit->entry[1]->isselected = "yes";
				break;
			case 'Mbits':
				$netunit->entry[2]->isselected = "yes";
				break;
			case 'bytes':
				$netunit->entry[3]->isselected = "yes";
				break;
			case 'Kbytes':
				$netunit->entry[4]->isselected = "yes";
				break;
			case 'Mbytes':
				$netunit->entry[5]->isselected = "yes";
				break;
			default:
				$netunit->entry[0]->isselected = "yes";
				break;
		}
		return $netunit;
	}
	// @return $obj
	// $value: mixed;
	// $obj: object;
	// $type: 0 - string; 1 - num;
	private function setValue($value, $obj, $type = 0) {
		if (isset($_POST[$value])) {
			if ($type == 0 && !empty($_POST[$value])) {
				$obj->{$value} = $this->stripMe($_POST[$value]);
			} elseif ($type == 1 && is_numeric($_POST[$value])) {
				$obj->{$value} = $this->stripMe($_POST[$value]);
			}
		} else {
			if (isset($obj->{$value}) && empty($_POST[$value])) {
				unset($obj->{$value});
			}
		}
		$newobj = & $obj;
		return $newobj;
	}
	// @return string;
	private function checkArrow($arrow) {
		switch ($arrow):
		case "circle":
			return "circle";
		case "halfarrow":
			return "halfarrow";
		default:
			return "normal";
		endswitch;
	}
	// @return string;
	private function checkUnit($unit) {
		switch ($unit):
		case "Kbits":
			return "Kbits";
		case "Mbits":
			return "Mbits";
		case "bytes":
			return "bytes";
		case "Kbytes":
			return "Kbytes";
		case "Mbytes":
			return "Mbytes";
		default:
			return "bits";
		endswitch;
	}
}
?>
