<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<title>Weathermap4PHP - Node</title>
		<script type="application/javascript" src="jscripts/form_node.js"></script>
		<link type="text/css" rel="stylesheet" href="css/form_node.css" />
	</head>
	<body>
		<div id="wrapper">
			<xsl:if test="debug">
				<div style="width: 90%; color: #fff; display: block;">
					<xsl:for-each select="debug/entry">
						<div style="width: 100%; border: 1px dashed #fff; background: #000fff; padding: 0.15em 0.25em 0.15em 0.25em;">
							<xsl:value-of select="text" />
						</div>		
					</xsl:for-each>
				</div>
			</xsl:if>
			<h2 style="margin-left: 10px;">Node parameters</h2>
			<hr noshade="noshade" style="color: #000;" />
			<form id="formnode" name="formnode" method="post" action="{formaction}">
				<div id="content">
					<table>
						<tr>
							<td>Node name :</td>
							<td>
								<input id="name" name="name" type="text" value="{name}" />
								<input id="oldname" name="oldname" type="hidden" value="{name}" />
							</td>
						</tr>
						<tr>
							<td>Node position in graph :</td>
							<td>
								<input id="x" name="x" type="text" size="3" value="{x}" />X 
								<input id="y" name="y" type="text" size="3" value="{y}" />Y
							</td>
						</tr>
						<tr>
							<td>Node label : </td>
							<td>
								<input id="label" name="label" type="text" value="{label}" />
							</td>
						</tr>
						<tr>
							<td>Node label type: </td>
							<td>
								<select name="labeltype">
									<xsl:for-each select="labeltype/entry">
										<option value="{name}">
											<xsl:if test="isselected">
												<xsl:attribute name="selected">selected</xsl:attribute>
											</xsl:if>
											<xsl:value-of select="name" />
										</option>
									</xsl:for-each>
								</select>
							</td>
						</tr>
						<tr>
							<td>Node icon : </td>
							<td>
								<select name="icon" onchange="updatePic(this.value)">
									<xsl:for-each select="icon/entry">
										<option value="{name}">
											<xsl:if test="isselected">
												<xsl:attribute name="selected">selected</xsl:attribute>
											</xsl:if>
											<xsl:value-of select="name" />
										</option>
									</xsl:for-each>
								</select>
							</td>
							<td rowspan="2">
								<img id="iconpic" style="min-height: 55px; min-width: 55px; max-height: 55px; max-width: 55px; width: 55px; height: 55px;" src="{icon/iconimg}" alt="" />
							</td>
						</tr>
						<tr>
							<td>Node icon position (optional) : </td>
							<td> 
								<input id="iconx" name="iconx" type="text" size="3" value="{iconx}" />X 
								<input id="icony" name="icony" type="text" size="3" value="{icony}" />Y
							</td>
						</tr>
						<tr>
							<td>Node icon transparency (optional) : </td>
							<td> 
								<input id="icontpt" name="icontpt" type="text" size="3" maxlength="3" value="{icontpt}" />% (0-100)
							</td>
						</tr>
						<tr>
							<td>Node icon resizing (optional) : </td>
							<td> 
								<input id="iconresize" name="iconresize" type="text" size="3" maxlength="3" value="{iconresize}" />% (0-100)
							</td>
						</tr>
						<tr>
							<td>Node information URL : </td>
							<td>
								<input id="infourl" name="infourl" type="text" size="30" value="{infourl}" />
							</td>
						</tr>
						<tr>
							<td>Node IP address : </td>
							<td>
								<input id="ip" name="ip" type="text" size="15" maxlength="15" value="{ip}" />
							</td>
						</tr>
						<tr>
							<td>Check node (method:port) : </td>
							<td>
								<select id="checkmethod" name="checkmethod" type="select">
									<xsl:for-each select="check">
										<option value="{name}">
											<xsl:if test="isselected">
												<xsl:attribute name="selected">selected</xsl:attribute>
											</xsl:if>
											<xsl:value-of select="name" />
										</option>
									</xsl:for-each>
								</select>
								<input id="checkport" name="checkport" maxlength="5" size="5" value="{checkport}" />
							</td>
						</tr>
					</table>
				</div>
				<!--- footer -->
				<hr noshade="noshade" style="#000;" />
				<div id="foot">	
					<div style="padding: 0.25em 0.5em 0.25em 0.5em">
						<xsl:for-each select="button/entry">
							<a href="{url}" style="margin-left: {margin}px;"><xsl:value-of select="urllabel" /></a>
						</xsl:for-each>
					</div>
				</div>
			</form>
		</div>
	</body>
</html>

